import {Inject, Injectable} from '@angular/core';
import {HttpClient} from '@angular/common/http';

import {TRANSLATE_CONFIG, TranslateConfig} from "./translate.config";

@Injectable({
  providedIn: 'root',
})
export class TranslateService {
  translations: any = {};
  autoGeneratedTranslations: any = {};

  selectedTranslation: string = '';

  defaultLanguage = 'en';
  useLocalStorage = true;
  languagesWithAutoTranslation: string[] = [];

  constructor(@Inject(TRANSLATE_CONFIG) private config: TranslateConfig, private http: HttpClient) {
    this.defaultLanguage = config?.defaultLanguage != null ? config.defaultLanguage : this.defaultLanguage;
    this.useLocalStorage = config?.useLocalStorage != null ? config.useLocalStorage : this.useLocalStorage;
    this.languagesWithAutoTranslation = config?.languagesWithAutoTranslation != null ? config.languagesWithAutoTranslation : this.languagesWithAutoTranslation;
  }

  translate(key: string) {
    let translation = this.translations[key];
    if (translation) {
      return translation;
    }

    translation = this.autoGeneratedTranslations[key];
    if (translation) {
      return translation;
    }

    return key;
  }

  use(pickedLanguage: string | null = null): Promise<{}> {
    let lang = '';
    if (pickedLanguage === null) {
      const language = this.useLocalStorage ? localStorage.getItem('language') : null;
      if (language != null) {
        lang = language;
        console.log('Language cookie found! Using "' + lang + '"');
      } else {
        lang = this.defaultLanguage;
        console.log('No language cookie found! Using "' + this.defaultLanguage + '" as default');
      }
    } else {
      console.log('Language changed to "' + lang + "'");
    }
    this.selectedTranslation = lang;
    if (this.useLocalStorage) {
      localStorage.setItem('language', lang);
    }

    return new Promise<{}>((resolve) => {
      const langPath = `assets/i18n/${lang || this.defaultLanguage}.json`;
      this.http.get<{}>(langPath).subscribe(
        (translation) => {
          this.translations = Object.assign({}, translation || {});
          resolve(this.translations);
        },
        () => {
          this.translations = {};
          resolve(this.translations);
        }
      );

      // Only fetch auto generated translation if there is one
      if (this.languagesWithAutoTranslation.includes(lang)) {
        const autoLangPath = `assets/i18n/${lang}_auto.json`;
        this.http.get<{}>(autoLangPath).subscribe(
          (translation) => {
            this.autoGeneratedTranslations = Object.assign({}, translation || {});
            resolve(this.autoGeneratedTranslations);
          },
          () => {
            this.autoGeneratedTranslations = {};
            resolve(this.autoGeneratedTranslations);
          }
        );
      }
    });
  }
}
